/**********************************************************************

UML StateWizard provides its software under two flexible licenses: 

1) the GPL License and zlib/libpng License for open source projects. 
2) the UML StateWizard Commercial License for commercial projects.

Email us at info@intelliwizard.com for any information, suggestions and 

feature requestions.

www.intelliwizard.com

*************************************************************************/

/*
FILE:EventId.h
NOTE: The State Machine Wizard will add mapping macros between /*{{ and /*}}. Do NOT modify manually.
*/

#ifndef EVENTID_H
#define EVENTID_H

#include "sme.h"

#ifdef __cplusplus
extern "C" {
#endif

enum
{
	/*{{SME_EVENT_ID_LIST_DECLARE*/
	// External event
	EXT_EVENT_ID_KEY_PRESS,
	EXT_EVENT_ID_TIMER,

	// Internal event
	EVENT_KEY_POWER,
	EVENT_POWER_UP,
	EVENT_ON_TIMER,
	EVENT_KEY_OK,
	EVENT_KEY_CANCEL,
	EVENT_KEY_LEFTSOFT,
	EVENT_KEY_RIGHTSOFT,
	EVENT_KEY_UP,
	EVENT_KEY_DOWN,
	EVENT_KEY_0,
	EVENT_KEY_1,
	EVENT_KEY_2,
	EVENT_KEY_3,
	EVENT_KEY_4,
	EVENT_KEY_5,
	EVENT_KEY_6,
	EVENT_KEY_7,
	EVENT_KEY_8,
	EVENT_KEY_9,

	EVENT_NULL,
	EVENT_OPEN_MENU_MAIN,
	EVENT_OPEN_MENU_LANG,
	EVENT_MENU_OK,
	EVENT_MENU_CANCEL,
	EVENT_IMAGE_OK,
	EVENT_IMAGE_CANCEL,
	EVENT_DLG_YES,
	EVENT_DLG_NO,
	EVENT_EDIT_OK,

	EVENT_PRE_PAGE,
	EVENT_NEXT_PAGE,
	EVENT_ON_SELECT,
	EVENT_ON_DISPLAY,
	EVENT_ON_EXIT,

	EVENT_MENU_SEL,
	EVENT_MENU_EXIT,
	EVENT_IMAGE_EXIT,
	EVENT_IMAGE_OPEN,
	EVENT_IMAGE_FUNC,
	EVENT_DLG_OK,
	EVENT_DLG_CANCEL,

	EVENT_FUNC_LANG_EN,
	EVENT_FUNC_LANG_CN,
	EVENT_FUNC_DISP,

	EVENT_OUT_OF_MEMORY,
	EVENT_ON_CALLING,

	EVENT_PLAY_START,
	EVENT_PLAY_STOP
	/*}}SME_EVENT_ID_LIST_DECLARE*/
};

#ifdef __cplusplus
}
#endif

#endif

